/**
 * Project Euler Problem 2.
 *
 * Sum of even Fibonacci numbers under 4 million.
 */
public class Problem002 implements EulerSolution { 

	public String run() { 
		return maxFib(4000000).toString();
	}

	public static Integer maxFib(Integer MAX) {
		if(MAX<=3) { 
			throw new IllegalArgumentException("MAX should be 4 or more.");
		}

		// Misread problem 002. 
		// Not the even-number-indexed Fibonacci terms,
		// but the Fibonacci numbers that are actually thesmelves even-valued.
		//
		// Now:
		// Consider all the Fibonacci numbers up to 4 million.
		// Find the sum of the even valued Fibonacci numbers.
		//
		// This is easier than I had been thinking.

		//Integer MAX = 10;
		Integer SUM = 0;

		// Fencepost
		Integer F_km2 = 1; // k = 1
		Integer F_km1 = 2; // k = 2
		Integer F_k = 3;
		Integer k = 3;

		SUM += 2; // <-- this was the trick to the problem.

		while(F_k < MAX) { // <-- make sure less than 4 million
			k++;
			F_km2 = F_km1;
			F_km1 = F_k;
			F_k = F_km2 + F_km1;

			if(F_k%2==0) { 
				SUM += F_k;
			}
		}

		return SUM;
	}

}

