import java.util.Collections;
import java.util.Arrays;
import java.util.Set;
import java.util.HashSet;

/**
 * Largest palindrome that is product of two 3-digit integers.
 * 
 * The key to this problem was:
 * a) KEEPING IT SIMPLE.
 * b) Realizing that the brute force key space is EXTREMELY SMALL.
 *
 * This all means that it is very, very easy to do the very, very easy thing,
 * which is, start with all possible 3-digit numbers, and generate 
 * a list of all possible products that are also palindromes. 
 * Then just take the max of that list.
 *
 * Wow. That was easy.
 */

public class Problem004 implements EulerSolution {

	public String run() {
		Set<Integer> max = new HashSet<Integer>();
		for(int i=100; i<999; i++) { 
			for(int j=100; j<999; j++) { 
				Integer prod = new Integer(i*j); 
				if(isPalindrome(prod)) { 
					max.add(prod);
				}
			}
		}
		return Collections.max(max).toString();
	}

	public static boolean isPalindrome(Integer i) { 
		String p = i.toString();
		if(p.equals(reverse(p))) { 
			return true;
		} else {
			return false;
		}
	}

	public static String reverse( String s ) {
		char[] r = new char[s.length()];
		int j=0;
		for(int i=s.length()-1; i>=0; i--) { 
			r[j] = s.charAt(i);
			j++;
		}
	    return new String(r);
	}
}
