import java.math.BigInteger;

/** For a 20 x 20 grid, we have 40 possible moves that can be swapped out.
 *
 * Total number of combinations is the binomial coefficient,
 *
 *       n!
 *   ----------
 *   k! (n-k)!
 *
 * where n and k are the two dimensions of the square.
 * In this case, the dimensions are equal, so we have:
 *
 *    40!
 *  -------
 *  20! 20!
 *
 *   (40 x 39 x ... x 22 x 21)
 *  ---------------------------
 *  ( 20 x 19 x ... x 3 x 2 x 1)
 *
 */
public class Problem015 { 
	
	public String run() { 
		BigInteger num = BigInteger.ONE;
		BigInteger denom = BigInteger.ONE;

		for(int i=40; i>20; i--) {
			num = num.multiply( BigInteger.valueOf(i) );
		}

		for(int i=20; i>0; i--) { 
			denom = denom.multiply( BigInteger.valueOf(i) );
		}

		return num.divide(denom).toString();

	}



}