import java.util.Collections;
import java.util.Arrays;
import java.util.Set;
import java.util.HashSet;
import java.util.TreeSet;
import java.util.List;
import java.util.ArrayList;

/**
 * Permuted Multiples.
 *
 * The trick here is to have chained methods, 
 * so that you stop multiplying as soon as you have a failure.
 * That, combined with the concept that we wanted 
 * the same SET of digits, meant we needed 
 * a method that would turn an arbitrary integer 
 * into a set of digits, 
 * and we could compare as we go.
 * */

public class Problem052 implements EulerSolution { 
	public static void main(String[] args) {
		Problem052 p = new Problem052();
		System.out.println(p.run());
	}

	public String run() { 
		boolean found = false;
		Set<Integer> digits = new HashSet<Integer>();

		int n = 100;
		while(!found) { 
			// 1x 
			Set<Integer> s = getSet(n);
			if(s.equals(getSet(2*n))) {
				if(s.equals(getSet(3*n))) {
					if(s.equals(getSet(4*n))) {
						if(s.equals(getSet(5*n))) {
							if(s.equals(getSet(6*n))) {
								found = true;
							}
						}
					}
				}
			}
			
			n++;
		}
		n--; // adjust
		return Integer.toString(n);
	}

	/** Turn a number n into a set of integer digits. */
	public static Set<Integer> getSet(int n) { 
		Set<Integer> result = new HashSet<Integer>();
		while(n!=0) { 
			// Successively shave off one digit
			int r = n%10;
			n = n/10;
			result.add(r);
		}
		return result;
	}

}
