/** Combinatorics:
 *
 * How many, not necessarily distinct, values of  nCr, 
 * for 1 ≤ n ≤ 100, are greater than one-million?
 */
public class Problem053 implements EulerSolution {
	public static void main(String[] args) { 
		Problem053 p = new Problem053();
		System.out.println(p.run());
	}

	/** Solve the problem. */
	public String run() {
		int MAX = 100;
		int count = 0;
		boolean[][] isBig = new boolean[MAX][MAX];
		for(int nm1=0; nm1<MAX; nm1++) { 
			for(int rm1=0; rm1<MAX; rm1++) { 
				// determine if n C r > 1M
				int n = nm1+1;
				int r = rm1+1;
				boolean big = isBigger(n,r);
				isBig[nm1][rm1] = big;
				if(big) count++;
			}
		}
		return Integer.toString(count);
		//System.out.println("Total number of n Choose r values that are greater than 1M: "+count);
	}

	/** Boolean: is n choose r bigger than 1 million? */
	public static boolean isBigger(int n, int r) {
		int d = (n-r);
		double LHS = 0.0;
		for(int j=0; j<d; j++) {
			LHS += Math.log(r+d-j) - Math.log(d-j);
		}
		double RHS = Math.log(1000000);
		return LHS > RHS;
	}
}
