import java.util.Queue;
import java.util.PriorityQueue;
import java.util.Iterator;
import java.math.BigInteger;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import java.util.HashMap;

public class Problem500 implements EulerSolution {
	public static final int FACTORS = 500500;
	public static final int BASE = 500500507;
	public static final BigInteger ONE = new BigInteger("1");
	public static final BigInteger TWO = new BigInteger("2");

	public static void main(String[] args) { 
		Problem500 p = new Problem500();
		System.out.println(p.run());
	}

	public String run() {  

		// This stores the next power of each prime factor
		PriorityQueue<Long> pq = new PriorityQueue<Long>();

		long b = 1;

		// Make a long list of primes - enough that we won't run out
		int sieveMax = (int)(FACTORS*Math.log(FACTORS)*Math.log(FACTORS));
		pq.addAll( Sieve.primeSieveInt( sieveMax ) );

		for(int i=0; i<FACTORS; i++) {

			// Two options:
			// - Multiply by a prime we have not used before
			// - Multiply by a prime that we have used k times before, k+1 times
			// Both of these will double the number of divisors.
			// Both will be in the priority queue.

			long pfactor = pq.remove();
			b = (b * pfactor)%BASE;

			// Once we use a prime factor, we can only re-usei t
			// when it reaches a new power of 2.
			pq.add(pfactor*pfactor);

		}

		return Long.toString(b);
	}

}

