import random
import math
import time


def main():
    #nn = [5, 10, 15, 20, 25, 30]
    #ss = [100, 1_000, 10_000]
    nn = [4]
    ss = [1_000_000]

    for n in nn:
        for s in ss:
            avg_rounds(n, s)


def avg_rounds(n, s):
    start = time.time()
    # --------------
    t = 0
    for _ in range(s):
        t += chase(n)
    end = time.time()
    # --------------
    print("---------")
    print(f"Number of players: {n}")
    print(f"Number of simulations: {s}")
    print(f"Average rounds: {round(t/s,14)}")
    print(f"Elapsed time: {round(end - start,3)} sec")

def round_to_n(x, n):
    return round(x, -int(math.floor(math.log10(x))) + (n - 1))

def increment_pointer(pointer, n):
    die = random.randint(1,6)
    if die == 1:
        pointer -= 1
        if pointer == 0:
            pointer = n
    elif die == 6:
        pointer += 1
        if pointer > n:
            pointer = 1
    return pointer

def chase(n):
    pointer1, pointer2 = 1, n//2
    rounds = 0
    while pointer1 != pointer2:
        rounds += 1
        pointer1 = increment_pointer(pointer1, n)
        pointer2 = increment_pointer(pointer2, n)
    return rounds

if __name__=="__main__":
    main()
