import random

"""
The Chase is a game played with two dice and an even number of players.

The players sit around a table and the game begins with two opposite players having one die each. On each turn, the two players with a die roll it.

If the player rolls 1, then the die passes to the neighbour on the left.
If the player rolls 6, then the die passes to the neighbour on the right.
Otherwise, the player keeps the die for the next turn.

The game ends when one player has both dice after they have been rolled and passed; that player has then lost.

In a game with 100 players, what is the expected number of turns the game lasts?

Give your answer rounded to ten significant digits.
"""

# Number of players
N = 100

def increment_pointer(pointer):
    die = random.randint(1,6)
    if die == 1:
        pointer -= 1
        if pointer == 0:
            pointer = N
    elif die == 6:
        pointer += 1
        if pointer > N:
            pointer = 1
    return pointer

pointer1, pointer2 = 1, N//2
rounds = 0
while pointer1 != pointer2:
    rounds += 1
    pointer1 = increment_pointer(pointer1)
    pointer2 = increment_pointer(pointer2)

print("Game over, man!")
print(f"Loser: {pointer1}")
print(f"Number of rounds: {rounds}")
