import java.util.List;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Collections;

/** Prime Spirals.
 *
 * This problem generates each number 
 * on the diagonal dynamically, and 
 * checks if it is a prime.
 */
public class Problem058 {
	public static void main(String[] args) { 
		System.out.println(solve());
	}

	public static String solve() { 
		Queue<Integer> q = new LinkedList<>();

		// Start the diagonals here 
		int ned = 3;
		int nwd = 5; 
		q.add(ned); q.add(nwd);

		// Compute the ratio of primes along both diagonals
		double ratio = 0.0;

		int row = 0;
		int primes = 0;
		int numbers = 0;

		while(!q.isEmpty()) {

			// Remove two diagonals (one row) at a time
			// (problem asks for ratio of primes on *both* diagonals)
			ned = q.remove(); numbers++;
			nwd = q.remove(); numbers++;
			row++;

			if(Sieve.isPrime(ned)) {
				primes++;
			}
			if(Sieve.isPrime(nwd)) {
				primes++;
			}

			// Update ratio
			ratio = (1.0*primes)/numbers;

			if(row%1000==0) { 
				System.out.println(row);
			}

			// If < 10%, return
			if(ratio <= 0.10) { 
				return Integer.toString(row+1);
			}

			// If not < 10%, increment i and compute next entries
			q.add(nextNE(ned,row+1));
			q.add(nextNW(nwd,row+1));

		}

		return null;
	}

	/** Compute the next entry on the northeast-southwest diagonal. */
	public static int nextNE(int nim1, int i) {
		return (nim1) + (2*i);
	}

	/** Compute the next entry on the northwest-southeast diagonal. */
	public static int nextNW(int nim1, int i) {
		return (nim1) + 4*(int)(Math.ceil(i/2.0));
	}
}