/** Nth power = Nth digit.
 *
 * Find numbers that are n digits long 
 * that are also nth powers.
 */
public class Problem063 { 
	public static void main(String[] args) { 
		solve();
	}

	public static void solve() {

		// These are the only numbers that qualify,
		// since 10^n is n+1 digits
		int counter = 0;
		for(int i=1; i<10; i++) { 
			// To check if a number i^j is j digits,
			// we take log10(j)
			// log10(i^j) = j * log10(i) 
			// if ceil(log10) == j, 
			// our criteria is met.
			// non-inclusive ceiling of n = 25,
			// since ceil( log10(9^25) ) = 23
			for(int j=1; j<25; j++) { 
				int ndigits = (int)(Math.ceil(j*Math.log10(i)));
				boolean jDigits = (ndigits==j);
				if(jDigits) { 
					counter++;
				}
					
			}
		}
		// This doesn't count 0^1, which is 0, also 1 digit.
		counter++;

		System.out.println(counter);

	}

}