import java.util.Scanner;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.FileNotFoundException;

public class LoadTriangle {

	public static final String FILE = "triangle.txt";

	/** Load a triangle from a file. */
	public static int[][] loadTriangle() {
		int nlines = countLines();
		int[][] triangle = new int[nlines][nlines];	
		try{ 
			Scanner s = new Scanner(new BufferedReader(new FileReader(FILE)));
			int r = 0;
			while(s.hasNextLine()) {
				String line = s.nextLine();
				Scanner ls = new Scanner(line);
				int c = 0;
				while(ls.hasNextInt()) {
					int num = ls.nextInt();
					triangle[r][c] = num;
					c++;
				}
				r++;
			}
		} catch(FileNotFoundException e) {
			e.printStackTrace();
		}
		return triangle;
	}

	/** Count the number of lines in the triangle file. */ 
	public static int countLines() { 
		int lines = 0;
		try{ 
			Scanner s = new Scanner(new BufferedReader(new FileReader(FILE)));
			while(s.hasNextLine()) { 
				s.nextLine();
				lines++;
			}
		} catch(FileNotFoundException e) {
			e.printStackTrace();
		}
		return lines;
	}
}
