import java.math.BigInteger;

/** 
 * Find the smallest number with 2^500500 divisors.
 *
 * This program builds from the ground up.
 * It relies on the procedure of multiplying
 * successively larger numbers, and uses a particular
 * procedure for choosing numbers in order to keep
 * the final product to a minimum.
 *
 * 2^500500 divisors means we choose 500500 factors
 * from our special table.
 *
 * But don't forget squares and cubes.
 *
 *
 *
 */
public class LotsaDivisorsBig {

	public static void main(String[] args) { 
		test();
	}



	public static void test() {
		// First number with 2^N divisors
		int N = 10;
		FactorGenerator f = new FactorGenerator(N);
		int i=0;
		while(f.hasNext() && i < N) { 
			int nxt = f.next();
			System.out.println(nxt);
			i++;
		}
	}




	public static void solve() {
		//int N = 500500;
		int N = 120;
		int MOD = 500500507;

		final BigInteger BASE = new BigInteger( Integer.toString(MOD) );
		FactorGenerator f = new FactorGenerator(N);
		int i=0;
		BigInteger product = BigInteger.ONE;
		while(f.hasNext() && i < N) { 
			int next = f.next();
			product = product.multiply( BigInteger.valueOf(next) ).mod(BASE);
			i++;
		}
		System.out.println(product);
	}
}

