import java.util.Random; 

public class DrawCastles {

	public static final Random coin = new Random();

	public static void main(String[] args) { 
		makeCastle(100,10);
	}

	public static boolean[][] makeCastle(int w, int h) { 
		//if(w>100 && h>100) { 
		//	throw new IllegalArgumentException();
		//}

		boolean[][] castle = new boolean[h][w]; // store as [row][column]

		// make a random castle
		makeRows(castle, w, h);
		printCastle(castle);
		
		return castle;
	}

	public static void makeRows(boolean[][] castle, int width, int height) { 
		recursiveRows(castle, 0, width, height);
	}

	public static boolean tossCoin() { 
		return (coin.nextDouble() < 0.8);
	}

	private static void recursiveRows(boolean[][] castle, int row, int maxcols, int maxrows) { 
		if(row==0) { 
			// bottom row - all solid
			for(int col=0; col<maxcols; col++) { 
				castle[row][col] = true;
			}
			recursiveRows(castle, row+1, maxcols, maxrows);
		} else if(row==1) { 
			// first eow - no constraints
			for(int col=0; col<maxcols; col++) { 
				castle[row][col] = tossCoin();
			}
			recursiveRows(castle, row+1, maxcols, maxrows);
		} else if(row<maxrows) { 
			// Row is at least 2.
			for(int col=0; col<maxcols; col++) { 
				if( castle[row-2][col] && castle[row-1][col] ) {
					// Toss a coin to see if we grow the tower 
					castle[row][col] = tossCoin(); 
				} 
				// otherwise, empty space.
			}
			recursiveRows(castle, row+1, maxcols, maxrows);
		} else {
			// Up to the tippy top
			return;
		}
	}


	public static void printCastle(boolean[][] castle) { 
		for(int row=castle.length-1; row>=0; row--) { 
			for(int col=0; col<castle[row].length; col++) { 
				if(castle[row][col]) { 
					System.out.print('X');
				} else {
					System.out.print(' ');
				}
			}
			System.out.print('\n');
		}
	}
}
