"""
Project Euler Problem 254:
Sum of Digit Factorials

This is slightly better than the naive implementation,
but it still takes an exceedingly large amount of time.
"""

factorial_memo = {}
f_memo = {}
sf_memo = {}
g_memo = {}
sg_memo = {}



# Utility:

def split_to_digits(n):
    d = list(str(n))
    return [int(z) for z in d]



# Factorial:

def fact(n):
    """Memoized factorial"""
    try:
        return factorial_memo[n]
    except KeyError:
        factorial_memo[n] = fact_(n)
        return factorial_memo[n]

def fact_(n):
    if n>1:
        return n*fact_(n-1)
    else:
        return 1



# Sum of factorial digits

def f(n):
    try:
        return f_memo[n]
    except KeyError:
        f_memo[n] = f_(n)
        return f_memo[n]

def f_(n):
    return sum([fact(z) for z in split_to_digits(n)])



# Sum of digits of sum of factorial digits

def sf(n):
    try:
        return sf_memo[n]
    except KeyError:
        sf_memo[n] = sf_(n)
        return sf_memo[n]

def sf_(n):
    return sum( split_to_digits(f(n)) )



# Minimum number such that sum of digits of sum of factorial digits is itself

def g(p):
    try:
        return g_memo[p]
    except KeyError:
        g_memo[p] = g_(p)
        return g_memo[p]

def g_(p):
    n = 1
    sf_val = sf(n)
    while sf_val != p:
        n+=1
        sf_val = sf(n)
    return n



# Sum of digits of minimum number, &c.

def sg(p):
    try:
        return sg_memo[p]
    except KeyError:
        sg_memo[p] = sg_(p)
        return sg_memo[p]

def sg_(p):
    return sum( split_to_digits( g(p) ) )



# Main method:

def test():
    # These tests all behave as expected
    print(split_to_digits(342))
    print(f(342))
    print(sf(342))
    print(sf(25))
    print(g(25))
    print(g(20))

    # This test goes really fast
    print(sum([sg(i) for i in range(1,21)]))

def solve()
    # This gets bogged down 
    summ = 0
    for i in range(41,44):
        print("Loop {i}".format(i=i))
        summ += sg(i)

    print("Final sum:")
    print(summ)

if __name__=="__main__":
    import cProfile
    pr = cProfile.Profile()
    pr.enable()
    solve()
    pr.disable()
    pr.print_stats()

